#include "StdAfx.h"

#include <wx/wx.h>

#include "MainWindow.h"

class MyApp: public wxApp {
	MainWindow *mainWindow;

public:
    bool OnInit();
	int  FilterEvent(wxEvent& event);
};

int  MyApp::FilterEvent(wxEvent& event) {
	if ( event.GetEventType()== wxEVT_KEY_DOWN) {
		int keyCode = ((wxKeyEvent&)event).GetKeyCode();

		TextureDisplay* canvas = mainWindow->getCanvas();

		if(keyCode == 'A')		canvas->keyDown(MOVE_LEFT);
		else if(keyCode == 'D') canvas->keyDown(MOVE_RIGHT);
		else if(keyCode == 'W') canvas->keyDown(MOVE_FRONT);
		else if(keyCode == 'S') canvas->keyDown(MOVE_BACK);
		else if(keyCode == 'Q') canvas->keyDown(BANK_LEFT);
		else if(keyCode == 'E') canvas->keyDown(BANK_RIGHT);
        
        return true;
    }
	else if(event.GetEventType()== wxEVT_KEY_UP) {
		int keyCode = ((wxKeyEvent&)event).GetKeyCode();

		TextureDisplay* canvas = mainWindow->getCanvas();

		if(keyCode == 'A')		canvas->keyUp(MOVE_LEFT);
		else if(keyCode == 'D') canvas->keyUp(MOVE_RIGHT);
		else if(keyCode == 'W') canvas->keyUp(MOVE_FRONT);
		else if(keyCode == 'S') canvas->keyUp(MOVE_BACK);
		else if(keyCode == 'Q') canvas->keyUp(BANK_LEFT);
		else if(keyCode == 'E') canvas->keyUp(BANK_RIGHT);
        
        return true;
	};
 
    return -1;

};

bool MyApp::OnInit() {
	mainWindow = new MainWindow(wxT("GPU Ray Tracer"));
    mainWindow->Show(true);

    return true;
}

IMPLEMENT_APP(MyApp)
//IMPLEMENT_APP_CONSOLE(MyApp)